/****************************************************************************

                Copyright (c) 2007 Aleksej Kozlov

****************************************************************************/

#include <os2.h>
#include <stdio.h>
#include <WPPersAB.h>
#include <WPPersDB.h>

void main(void)
{
  PAddressBookList list;
  PAddressBookList ptr;
  WPPHANDLE obj;
  long i;
  char path[CCHMAXPATH] = "";

  printf("\ngetting all address books in \"<WP_ADDRESSBOOK>\"...\n");
  if(WPPGetAddressBookList(NULL, WPPAB_IncludeAddressBooks | WPPAB_IncludeRootAddressBook | WPPAB_Recursive, &list) == 0)
  {
    strcpy(path, list->FileName); //path to <WP_ADDRESSBOOK> - first in list

    for(ptr = list; ptr; ptr = ptr->Next)
    {
      for(i = 0; i <= ptr->IncLevel; i++)
        printf("    ");
      printf("%s\n", ptr->DisplayName);
    }
    WPPFreeAddressBookList(list);
  }
  else
  {
    printf("error occured!\n");
    return;
  }

  printf("\ngetting all personal cards in \"<WP_ADDRESSBOOK>\"...\n");
  if(WPPGetAddressBookList(NULL, WPPAB_IncludePersonalCards | WPPAB_IncludeAddressBooks | WPPAB_IncludeRootAddressBook | WPPAB_Recursive, &list) == 0)
  {
    for(ptr = list; ptr; ptr = ptr->Next)
    {
      for(i = 0; i <= ptr->IncLevel; i++)
        printf("    ");
      printf(ptr->IsAddressBook ? "[%s]\n" : "%s\n", ptr->DisplayName);
    }
    WPPFreeAddressBookList(list);
  }
  else
  {
    printf("error occured!\n");
    return;
  }

  if(path[0])
  {
    char test_book_name[] = "Test AddrBook";
    printf("\ncreating address book \"%s\" in \"%s\"\n", test_book_name, path);
    if(WPPCreateAddressBook(path, test_book_name, NULL) == 0)
    {
      strcat(path, "\\");
      strcat(path, test_book_name);
    }
    else
    {
      printf("error occured!\n");
    }

    printf("\ncreating personal card \"John Smith\" in \"%s\"\n", path);
    obj = WPPCreateObject();
    if(obj)
    {
      strcat(path, "\\Smith, John.wpp");
      WPPSetAttr(obj, NULL, path); //file name
      WPPSetAttr(obj, "x-n-given", "John");
      WPPSetAttr(obj, "x-n-family", "Smith");
      WPPSetAttr(obj, "x-n-nickname", "Johnny");
      WPPSetAttr(obj, "email;internet", "smith@johnny.somewhere");
      WPPSetAttr(obj, "url", "http://www.johnny.somewhere");
      WPPSetAttr(obj, "tel;home;voice", "(812)123-4567");
      if(WPPFileWriteObject(obj) != 0)
        printf("error occured!\n");
      //WPPDestroyObject(obj);
    }
    else
    {
      printf("error occured!\n");
    }
  }
}
